/*==========================================================================
 *
 *  Copyright (C) 2004 Jumpei Isshiki. All Rights Reserved.
 *
 *  File	:act_bg.c
 *  Content	:wiANg֘A
 *  Program	:J.Issiki
 *  Date	:2004/2/2
 *  UpDate	:2004/2/2
 *
 *  * Sat Dec 09 18:16:07 JST 2006 Naoyuki Sawa
 *  - P/ECEւ̈ڐÂ߁A啝ɕύX܂B
 *
 ==========================================================================*/
#include "app.h"

static void actScroll(ACT* actp);

void
actBg(ACT* actp)
{
	switch(actp->step) {
	/*  */
	case 0:
		ACTnextStep();
		break;

	/* C */
	case 1:
		/* t[Awi̐𐶐 */
		ACTsetBtm(actScroll, GROUP_EFFECT);
		break;

	/* I */
	default:
		ACTclear(actp);
		break;
	}
}

void
actFrame(ACT* actp)
{
	int pos_x;

	switch(actp->step) {
	/*  */
	case 0:
		actp->pos[X] = fld(0.0);
		actp->wait = 60;
		ACTnextStep();
		break;

	/* C */
	case 1:
		pos_x = fist(actp->pos[X]);
		DrawBox(  0      , 0, 320-pos_x, 480, 2);
		DrawBox(320+pos_x, 0, 640      , 480, 2);
		if(actp->wait) {
			actp->wait--;
		} else {
			actp->wait = 60;
			ACTnextStep();
		}
		break;
	case 2:
		pos_x = fist(actp->pos[X]);
		DrawBox(  0      , 0, 320-pos_x, 480, 2);
		DrawBox(320+pos_x, 0, 640      , 480, 2);
		if(actp->wait) {
			actp->wait--;
			fadd_(actp->pos[X], fld((640.0 - 256.0) / 2.0 / 60));
		} else {
			ACTnextStep();
		}
		break;

	/* I */
	default:
		ACTclear(actp);
		break;
	}
}

static void
actScroll(ACT* actp)
{
	int pos[XY];

	switch(actp->step) {
	/*  */
	case 0:
		actp->pos[X] = FRND_RANGE(seed, fld(128.0), fld(640.0-128.0));
		actp->pos[Y] = fld(-16.0);
		actp->vel[Y] = FRND_RANGE(seed, fld(1.0), fld(5.0));	/* 1.00`4.99 */
		ACTnextStep();
		break;

	/* C */
	case 1:
		fadd_(actp->pos[Y], actp->vel[Y]);
		pos[X] = scr_pos[X] + fist(actp->pos[X]);
		pos[Y] = scr_pos[Y] + fist(actp->pos[Y]);
		DrawPoint(pos[X], pos[Y], 2);
		if(fcom(actp->pos[Y], >, fld(480.0 + 16.0))) {
			ACTexitStep();
		}
		break;

	/* I */
	default:
		ACTclear(actp);
		break;
	}
}

void
actQuake(ACT* actp)
{
	int tmp;

	switch(actp->step) {
	/*  */
	case 0:
		actp->wait = actp->cnt / 2;
		ACTnextStep();
		break;

	/* C */
	case 1:
		scr_pos[X] = 0;
		scr_pos[Y] = 0;
		if(actp->cnt) {
			actp->cnt--;
		} else {
			ACTexitStep();
			break; /* ܂ */
		}
		tmp = fist(actp->vel[X]) / 2;
		if(tmp) {
			scr_pos[X] = RND32_RANGE(seed, -tmp, tmp);	/* -vel[X]/2`+vel[X]/2 */
			fsub_(actp->vel[X], fidiv(actp->vel[X], actp->wait));
		}
		tmp = fist(actp->vel[Y]) / 2;
		if(tmp) {
			scr_pos[Y] = RND32_RANGE(seed, -tmp, tmp);	/* -vel[Y]/2`+vel[Y]/2 */
			fsub_(actp->vel[Y], fidiv(actp->vel[Y], actp->wait));
		}
		break;

	/* I */
	default:
		ACTclear(actp);
		break;
	}
}

