/*==========================================================================
 *
 *  Copyright (C) 2004 Jumpei Isshiki. All Rights Reserved.
 *
 *  File	:act_boss01.c
 *  Content	:GANg֘A
 *  Program	:J.Issiki
 *  Date	:2004/3/15
 *  UpDate	:2004/3/23
 *
 *  * Sat Dec 09 18:16:07 JST 2006 Naoyuki Sawa
 *  - P/ECEւ̈ڐÂ߁A啝ɕύX܂B
 *
 ==========================================================================*/
#include "app.h"

static int pal;

static void actBoss01Int(ACT* actp);

void
actBoss01(ACT* actp)
{
	ACT* eactp;
	int pos[XY];
	int color;

	switch(actp->step) {
	/*  */
	case 0:
		actp->actid = ACTF_ENEMY|ACTF_MUTEKI;
		actp->col[X] = fld(16 * 9);
		actp->col[Y] = fld(7 * 16);
		actp->energy = 160;
		actp->int_adr = actBoss01Int;
		actp->trg[X] = actp->pos[X];
		actp->trg[Y] = actp->pos[Y];
		actp->pos[Y] = fidiv(actp->col[Y], -2);
		actp->wait = 60;
		actp->cnt = 0;
		ACTnextStep();
		break;

	/* C */
	case 1:
		if(actp->wait) {
			actp->wait--;
		} else {
			actp->cnt = 1;
			actp->actid &= ~ACTF_MUTEKI;
			ACTnextStep();
		}
		/*FALLTHRU*/
	case 2:
		/* ړ */
		fadd_(actp->pos[X], fidiv(fsub(actp->trg[X], actp->pos[X]), 30));
		fadd_(actp->pos[Y], fidiv(fsub(actp->trg[Y], actp->pos[Y]), 30));
		/* e */
		if(actp->step == 2 && BulletMLisEnd(actp)) {
			switch(actp->cnt) {
			case 0:
				/** no job **/
				break;
			case 1:
			case 2:
			case 3:
			case 4:
			case 5:
			case 6:
			case 7:
			case 8:
				BulletMLaddCtrl(actp, 9);
				actp->cnt++;
				break;
			case 9:
			case 10:
			case 11:
			case 12:
				BulletMLaddCtrl(actp, 8);
				actp->cnt++;
				break;
			default:
				actp->cnt = 1;
				break;
			}
		}
		BulletMLexecCtrl(actp);
		/* \ */
		if(!tstFLG(actp->actid, ACTF_MUTEKI)) {
			color = 0;
		} else {
			if(actp->step == 2) {
				actp->actid &= ~ACTF_MUTEKI;
			}
			color = 1;
		}
		pos[X] = scr_pos[X] + fist(actp->pos[X]) - 16 *  9 / 2;
		pos[Y] = scr_pos[Y] + fist(actp->pos[Y]) -  7 * 16 / 2;
		DrawString(pos[X], pos[Y], "    ________    ", color); pos[Y] += 16;
		DrawString(pos[X], pos[Y], "  _|__    __|_  ", color); pos[Y] += 16;
		DrawString(pos[X], pos[Y], "_|_| _|__|_ |_|_", color); pos[Y] += 16;
		DrawString(pos[X], pos[Y], "|  | |    | |  |", color); pos[Y] += 16;
		DrawString(pos[X], pos[Y], "|__| |____| |__|", color); pos[Y] += 16;
		DrawString(pos[X], pos[Y], " |_|__|  |__|_| ", color); pos[Y] += 16;
		DrawString(pos[X], pos[Y], "   |________|   ", color);
		break;

	/* j */
	case 10:
		soundPlaySe(SE_EXP02);
		if(time_left) {
			soundPlaySe(SE_EXTEND);
			time_left += 10 * ONE_SEC;
			eactp = ACTsetTop(actMessage, GROUP_08);
			Message = "TIME EXTEND 10SEC.";
			eactp->cnt = 60 * 3;
			eactp->pos[X] = fld(SCR_MX - strlen(Message) * 9 / 2);
			eactp->pos[Y] = fld(240 - 8);
			actp->wait = 60 * 3;
		}
		eactp = ACTsetBtm(actQuake, GROUP_07);
		eactp->cnt = 32;
		eactp->vel[X] = fld(64.0);
		eactp->vel[Y] = fld(64.0);
		eactp = ACTsetBtm(actClrEnemy, GROUP_SSHOT);
		eactp->prog_adr(eactp);
		BulletMLdelCtrl(actp);
		pal = 255;
		actp->wait = 32;
		ACTnextStep();
		/*FALLTHRU*/
	case 11:
		if(actp->wait) {
			actp->wait--;
			     if(pal > 170) color = 0;
			else if(pal >  85) color = 1;
			else               color = 2;
			pal -= 8;
		} else {
			ACTexitStep();
			break; /* ܂ */
		}
		/* \ */
		pos[X] = scr_pos[X] + fist(actp->pos[X]) - 16 *  9 / 2;
		pos[Y] = scr_pos[Y] + fist(actp->pos[Y]) -  7 * 16 / 2;
		DrawString(pos[X], pos[Y], "    ________    ", color); pos[Y] += 16;
		DrawString(pos[X], pos[Y], "  _|__    __|_  ", color); pos[Y] += 16;
		DrawString(pos[X], pos[Y], "_|_| _|__|_ |_|_", color); pos[Y] += 16;
		DrawString(pos[X], pos[Y], "|  | |    | |  |", color); pos[Y] += 16;
		DrawString(pos[X], pos[Y], "|__| |____| |__|", color); pos[Y] += 16;
		DrawString(pos[X], pos[Y], " |_|__|  |__|_| ", color); pos[Y] += 16;
		DrawString(pos[X], pos[Y], "   |________|   ", color);
		break;

	/* I */
	default:
		ACTclear(actp);
		enemy_cnt--;
		break;
	}
}

static void
actBoss01Int(ACT* actp)
{
	ACT* eactp = actp->ext_dat;

	if(tstFLG(eactp->actid, ACTF_SSHOT)) {
		actSetParticle(eactp);
	} else {
		actSetParticle(actp);
	}
	if(!tstFLG(actp->actid, ACTF_MUTEKI)) {
		actp->actid  |= ACTF_MUTEKI;
		actp->energy -= eactp->energy;
		score += 1;
		if(actp->energy <= 0) {
			actp->actid &= ~ACTF_ENEMY;
			ACTsetStep(10);
			score += 25;
			actEnemyChkDest();
		} else {
			soundPlaySe(SE_DMG01);
		}
	}
}

