/*==========================================================================
 *
 *  Copyright (C) 2004 Jumpei Isshiki. All Rights Reserved.
 *
 *  File	:act_ene00.c
 *  Content	:GANg֘A
 *  Program	:J.Issiki
 *  Date	:2004/3/6
 *  UpDate	:2004/3/23
 *
 *  * Sat Dec 09 18:16:07 JST 2006 Naoyuki Sawa
 *  - P/ECEւ̈ڐÂ߁A啝ɕύX܂B
 *
 ==========================================================================*/
#include "app.h"

static void actEnemy00Int(ACT* actp);
static void actChip(ACT* actp);
static void actChipInt(ACT* actp);

void
actEnemy00(ACT* actp)
{
	int pos[XY];
	int color;

	switch(actp->step) {
	/*  */
	case 0:
		actp->actid = ACTF_ENEMY;
		actp->col[X] = fld(3 *  9);
		actp->col[Y] = fld(2 * 16);
		actp->energy = 5;
		actp->int_adr = actEnemy00Int;
		if(actp->cnt & 0x01) {
			actp->pos[X] = fld(SCR_SX + 32);
		} else {
			actp->pos[X] = fld(SCR_EX - 32);
		}
		actp->pos[Y] = fld(-16.0);
		actp->vel[X] = fld(0.0);
		actp->vel[Y] = fld(1.0);
		ACTnextStep();
		break;

	/* C */
	case 1:
		/* ړ */
		fadd_(actp->pos[X], actp->vel[X]);
		fadd_(actp->pos[Y], actp->vel[Y]);
		if(fcom(actp->pos[Y], >, fld(480.0+16.0))) {
			ACTexitStep();
			break; /* ܂ */
		}
		/* \ */
		if(!tstFLG(actp->actid, ACTF_MUTEKI)) {
			color = 0;
		} else {
			actp->actid &= ~ACTF_MUTEKI;
			color = 1;
		}
		pos[X] = scr_pos[X] + fist(actp->pos[X]) - 3 *  9 / 2;
		pos[Y] = scr_pos[Y] + fist(actp->pos[Y]) - 2 * 16 / 2;
		DrawString(pos[X], pos[Y], "[=]", color); pos[Y] += 16;
		DrawString(pos[X], pos[Y], "[=]", color);
		break;

	/* I */
	default:
		ACTclear(actp);
		break;
	}
}

static void
actEnemy00Int(ACT* actp)
{
	ACT* eactp = actp->ext_dat;

	if(tstFLG(eactp->actid, ACTF_SSHOT)) {
		actSetParticle(eactp);
	} else {
		actSetParticle(actp);
	}
	if(!tstFLG(actp->actid, ACTF_MUTEKI)) {
		actp->actid  |= ACTF_MUTEKI;
		actp->energy -= eactp->energy;
		score += 1;
		if(actp->energy <= 0) {
			actp->actid &= ~ACTF_ENEMY;
			eactp = ACTsetTop(actChip, GROUP_ENEMY);
			eactp->pos[X] = actp->pos[X];
			eactp->pos[Y] = actp->pos[Y];
			eactp->cnt = actp->cnt;
			soundPlaySe(SE_EXP00);
			ACTexitStep();
			score += 1;
		}
	}
}

static void
actChip(ACT* actp)
{
	int pos[XY];

	switch(actp->step) {
	/*  */
	case 0:
		actp->actid = ACTF_CHIP;
		actp->col[X] = fld(32.0);
		actp->col[Y] = fld(32.0);
		actp->energy = 10;
		actp->int_adr = actChipInt;
		actp->vel[X] = fld(0.0);
		actp->vel[Y] = fld(1.0);
		if(!actp->cnt || (actp->cnt % 0x08)) {
			actp->cnt = 0;
		} else {
			actp->cnt = 1;
		}
		ACTnextStep();
		break;

	/* C */
	case 1:
		/* ړ */
		fadd_(actp->pos[X], actp->vel[X]);
		fadd_(actp->pos[Y], actp->vel[Y]);
		if(fcom(actp->pos[Y], >, fld(480.0+16.0))) {
			ACTexitStep();
			break; /* ܂ */
		}
		/* \ */
		if(frame & 0x01) {
			pos[X] = scr_pos[X] + fist(actp->pos[X]) - 1 *  9 / 2;
			pos[Y] = scr_pos[Y] + fist(actp->pos[Y]) - 1 * 16 / 2;
			if(!actp->cnt) {
				DrawString(pos[X], pos[Y], "P", 0);
			} else {
				DrawString(pos[X], pos[Y], "B", 0);
			}
		}
		break;

	/* I */
	default:
		ACTclear(actp);
		break;
	}
}

static void
actChipInt(ACT* actp)
{
	actp->actid &= ~ACTF_CHIP;
	ACTexitStep();
}

