/*==========================================================================
 *
 *  Copyright (C) 2004 Jumpei Isshiki. All Rights Reserved.
 *
 *  File	:act_enemy.c
 *  Content	:GANg֘A
 *  Program	:J.Issiki
 *  Date	:2004/2/3
 *  UpDate	:2004/3/23
 *
 *  * Sat Dec 09 18:16:07 JST 2006 Naoyuki Sawa
 *  - P/ECEւ̈ڐÂ߁A啝ɕύX܂B
 *
 ==========================================================================*/
#include "app.h"

static void actEnemyBulletInt(ACT* actp);

void
actParticle(ACT* actp)
{
	int pos[XY];

	switch(actp->step) {
	/*  */
	case 0:
		actp->vel[X] = FRND_RANGE(seed, fld(-8), fld(8));	/* -8.00`+7.99 */
		actp->vel[Y] = FRND_RANGE(seed, fld(-8), fld(8));	/* -8.00`+7.99 */
		actp->wait = 15;
		ACTnextStep();
		break;

	/* C */
	case 1:
		/* ړ */
		fadd_(actp->pos[X], actp->vel[X]);
		fadd_(actp->pos[Y], actp->vel[Y]);
		if(actp->wait) {
			actp->wait--;
		} else {
			ACTexitStep();
			break; /* ܂ */
		}
		/* \ */
		pos[X] = scr_pos[X] + fist(actp->pos[X]);
		pos[Y] = scr_pos[Y] + fist(actp->pos[Y]);
		DrawPoint(pos[X], pos[Y], 0);
		break;

	/* I */
	default:
		ACTclear(actp);
		break;
	}

}

void
actSetParticle(ACT* actp)
{
	int lp1;
	ACT* eactp;

	for(lp1 = 0; lp1 < 4; lp1++) {
		eactp = ACTsetBtm(actParticle, GROUP_EFFECT);
		eactp->pos[X] = actp->pos[X];
		eactp->pos[Y] = actp->pos[Y];
		eactp->prog_adr(eactp);
	}
}

void
actEnemyBullet(ACT* actp)
{
	int pos[XY];

	switch(actp->step) {
	/*  */
	case 0:
		actp->actid |= ACTF_ESHOT;
		//actp->col[X] = fld(2.0);
		//actp->col[Y] = fld(2.0);
		//Sat Dec 09 18:08:52 JST 2006 Naoyuki Sawa
		actp->col[X] = fld(4.0);
		actp->col[Y] = fld(4.0);
		actp->int_adr = actEnemyBulletInt;
		ACTnextStep();
		break;

	/* C */
	case 1:
		/* ړ */
		BulletMLexecCtrl(actp);
		fadd_(actp->pos[X], fmul(fsin(actp->bul_rot), actp->bul_vel));
		fsub_(actp->pos[Y], fmul(fcos(actp->bul_rot), actp->bul_vel)); /* AvP[VBulletML̊px̊̈Ⴂ̂߁AZɂȂ܂!! */
		fadd_(actp->pos[X], actp->bul_acc[X]);
		fadd_(actp->pos[Y], actp->bul_acc[Y]);
		if(fcom(actp->pos[X], <, fld(      128.0-16.0)) ||
		   fcom(actp->pos[X], >, fld(640.0-128.0+16.0))) {
			ACTexitStep();
			break; /* ܂ */
		}
		if(fcom(actp->pos[Y], <, fld(     -16.0)) ||
		   fcom(actp->pos[Y], >, fld(480.0+16.0))) {
			ACTexitStep();
			break; /* ܂ */
		}
		/* \ */
		pos[X] = scr_pos[X] + fist(actp->pos[X]) - 1 *  9 / 2;
		pos[Y] = scr_pos[Y] + fist(actp->pos[Y]) - 1 * 16 / 2;
		DrawString(pos[X], pos[Y], "o", 0);
		break;

	/* I */
	default:
		ACTclear(actp);
		break;
	}
}

static void
actEnemyBulletInt(ACT* actp)
{
	score += 1;
	actSetParticle(actp);
	actp->actid &= ~ACTF_ESHOT;
	ACTexitStep();
}

void
actEnemyChkDest()
{
	//rankAdd(fld(0.001)); /* 肬Œ菬̐xB1/1024ɂȂ܂B */
	//1/1000Ȃ̂1/1024ɂ邩1/512ɂ邩łA1/512ɂ܂ */
	rankAdd(fld(0.002));
	if(!(++enemy_dest % 0x20)) {
		ACT* eactp = ACTsetTop(actEnemy00, GROUP_ENEMY);
		eactp->cnt = enemy_carry++; /* bit0 = Left/Right, bit3 = Power/Bomb */
	}
}

void
actClrEnemy(ACT* actp)
{
	switch(actp->step) {
	/*  */
	case 0:
		actp->actid = ACTF_BOMB;
		actp->energy = 1;
		actp->pos[X] = fld(320.0);
		actp->pos[Y] = fld(240.0);
		actp->col[X] = fld(640.0 - (128.0 * 2.0));
		actp->col[Y] = fld(480.0);
		ACTnextStep();
		break;

	/* C */
	case 1:
		ACTexitStep();
		break;

	/* I */
	default:
		ACTclear(actp);
		break;
	}
}

